﻿@model PROJETMODELE.Models.VML.TP.CommandeVM
@{
    Layout = null;
}
<script src="~/Scripts/AjouterJS.js"></script>
<div id="formulaire">
    <div>Nouvelle Commande</div>
    <div class="forms">
        <input id="validerUrl" value="/Commande/Ajouter/" type="hidden" />
        <input id="supprimerUrl" value="/Commande/Supprimer_Detail_Liquide/" type="hidden" />
        <input id="materielUrl" value="/Commande/Add_Liquide" type="hidden" />
        <input id="supprimer_emballageUrl" value="/Commande/Supprimer_Detail_Emballage/" type="hidden" />
        <input id="materiel_emballageUrl" value="/Commande/Add_Emballage" type="hidden" />
        <input id="annulerUrl" value="/Commande/Annuler_Commande" type="hidden" />
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            @Html.ValidationSummary(true)    
            <div id='jqxWidget'>
                <div id='jqxTabs'>
                    <ul>
                      
                        <li style="margin-left: 30px;"> Liquide</li>
                        <li>Emballage</li>
                    </ul>
                    
                    <div class="section">
                        <table style="width: 60%; margin: 0 auto;">
                           
                            <tr>
                                <td>@Html.LabelFor(model=>model.ID_Fournisseur)</td>
                                <td>
                                    @HTML_OUF.DropDownList("ID_Fournisseur",TempData["ID_Fournisseur"] as SelectList,"280")
                                    
                                </td>                                
                            </tr>
                                                       
                        </table>
                        <table style="width: 70%; margin: 0 auto; border-collapse: collapse;" class="encadrer_tout">
                            <tr>
                                <th colspan="3" style="background-color:#999999">Produit</th>
                                <th colspan="3" style="background-color:#808080">Emballage</th>
                            </tr>
                            <tr>
                                <td width="180px">
                                    @Html.LabelFor(model=>model.ID_Produit)
                                </td>
                                <td width="100px">
                                    @Html.LabelFor(model=>model.Quantite_Casier_Liquide)
                                </td>
                                <td width="100px">
                                    @Html.LabelFor(model=>model.Quantite_Bouteille_Liquide)
                                </td>
                                <td width="100px">
                                    @Html.LabelFor(model=>model.Quantite_Casier_Emballage)
                                </td>
                                <td width="100px">
                                    @Html.LabelFor(model=>model.Quantite_Plastique_Emballage)
                                </td>
                                <td width="100px">
                                    @Html.LabelFor(model=>model.Quantite_Bouteille_Emballage)
                                </td>
                            </tr>
                            <tr>
                                <td >
                                    @HTML_OUF.DropDownList("ID_Produit", TempData["ID_Produit"] as SelectList,"280")
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Casier_Liquide, new { autocomplete = "off" })
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Bouteille_Liquide, new { autocomplete = "off" })
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Casier_Emballage, new { autocomplete = "off" })
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Plastique_Emballage, new { autocomplete = "off" })
                                </td>
                                <td>
                                    @Html.TextBoxFor(model=>model.Quantite_Bouteille_Emballage, new { autocomplete = "off" })
                                </td>
                            </tr>
                            
                        </table>
                        <table  style="width: 60%; margin: 0 auto;">
                            <tr >
                                <td style="text-align: left">
                                    <button title="Supprimer" value="Supprimer" type="button" id="supprimer" class="btn btn-default oufbutton  action"><i class="ouf-delete"></i>Supprimer</button>
                                </td>
                                <td style="text-align: left" colspan="2">
                                    <button title="Ajouter" value="Ajouter" type="button" id="materiel" class="btn btn-default oufbutton  action"><i class='ouf-ok'></i>Ajouter</button>
                                </td>
                                
                                
                            </tr>
                        </table>
                        <table style="width: 80%; margin: 0 auto;">
                            <tr>
                                <td style="font-weight:bold; ">Montant Liquide : <span id="Montant" style="font-size:1.3em">0</span> FCFA</td>
                                <td style="font-weight:bold; text-align:right">Montant Emballage : <span id="Montant_Emballage_1" style="font-size:1.3em">0</span> FCFA</td>
                            </tr>
                      
                        </table>
                        <div id="gradesm"></div>
                        <table style="width: 60%; margin: 0 auto;" >
                            <tr>
                            <td   >
                                <button title="Annuler" value="Annuler" type="button" id="annuler" class="btn btn-default oufbutton  action"><i class="ouf-cancel"></i>Annuler</button>
                            </td>
                            <td  >
                                <button title="Valider" value="Valider" type="button" id="valider" class="btn btn-default oufbutton  action"><i class="ouf-ok"></i>Valider</button>
                            </td>
                               
                        </tr>
                        </table>
                    </div>
                    <div class="section">
                                                                      
                        <table style="width: 40%; margin: 0 auto;">
                            <tr>
                                <td colspan="2">@Html.Label("Tout Retourner :")</td>
                                <td colspan="2">@Html.CheckBox("Tout_Retourner")</td>
                            </tr>
                            <tr>
                                <td width="50px">@Html.LabelFor(model => model.ID_Emballage)</td>
                                <td>@Html.LabelFor(model => model.Quantite_Casier_Emballage_Retour)</td>
                                <td>@Html.LabelFor(model => model.Quantite_Plastique_Emballage_Retour)</td>
                                <td>@Html.LabelFor(model => model.Quantite_Bouteille_Emballage_Retour)</td>
                            </tr>
                            <tr>
                                <td width="50px">@Html.Label("C12")</td>
                                <td>@Html.TextBoxFor(model => model.Casier_12, new { autocomplete = "off" })</td>
                                <td>@Html.TextBoxFor(model => model.Plastique_12, new { autocomplete = "off" })</td>
                                <td>@Html.TextBoxFor(model => model.Bouteille_12, new { autocomplete = "off" })</td>
                            </tr>
                            <tr>
                                <td width="50px">@Html.Label("C15")</td>
                                <td>@Html.TextBoxFor(model => model.Casier_15, new { autocomplete = "off" })</td>
                                <td>@Html.TextBoxFor(model => model.Plastique_15, new { autocomplete = "off" })</td>
                                <td>@Html.TextBoxFor(model => model.Bouteille_15, new { autocomplete = "off" })</td>
                            </tr>
                            <tr>
                                <td width="50px">@Html.Label("C24")</td>
                                <td>@Html.TextBoxFor(model => model.Casier_24, new { autocomplete = "off" })</td>
                                <td>@Html.TextBoxFor(model => model.Plastique_24, new { autocomplete = "off" })</td>
                                <td>@Html.TextBoxFor(model => model.Bouteille_24, new { autocomplete = "off" })</td>
                            </tr>                                                                        
                            
                            
                        </table>

                        <table style="width: 60%; margin: 0 auto;">
                            <tr>
                                <td style="text-align: left" >
                                    <button title="Supprimer" value="Supprimer" type="button" id="supprimer_emballage" class="btn btn-default oufbutton  action"><i class="ouf-delete"></i>Supprimer</button>
                                </td>
                                <td style="text-align: left">
                                    <button title="Ajouter" value="Ajouter" type="button" id="materiel_emballage" class="btn btn-default oufbutton  action"><i class='ouf-ok'></i>Ajouter</button>
                                </td>
                                
                            </tr>
                        </table>
                        
                        <table style="width: 80%;">
                            <tr>
                                <td style="font-weight:bold; ">Retour Emballage : <span id="Retour_Emballage" style="font-size:1.3em">0</span> FCFA</td>
                            </tr>
                        </table>
                        <div id="gradesmemballage"></div>
                        
                    </div>
                    
                </div>
            </div>
        }
    </div>
</div> 
<script>

    
    //validation par jqxvalidator
    $('#formulaire').jqxValidator({
        rules: [

        ],
    });
   
   
    
    
    
    $('#formulaire').jqxWindow({ height: "90%", width: "98%", isModal: true, showCloseButton: true, theme: "ui-redmond", maxWidth: "1100" });
    //Initializing the wizard
     $('#jqxTabs').jqxTabs({ height: 'auto', width: '100%', theme: "ui-redmond" });
     $("#Quantite_Casier_Liquide").jqxInput({ placeHolder: " ", height: 25, width: 75, theme: "ui-redmond" });
     $("#Quantite_Bouteille_Liquide").jqxInput({ placeHolder: " ", height: 25, width: 75, theme: "ui-redmond" });
     $("#Quantite_Casier_Emballage").jqxInput({ placeHolder: " ", height: 25, width: 75, theme: "ui-redmond" });
     $("#Quantite_Plastique_Emballage").jqxInput({ placeHolder: " ", height: 25, width: 75, theme: "ui-redmond" });
     $("#Quantite_Bouteille_Emballage").jqxInput({ placeHolder: " ", height: 25, width: 75, theme: "ui-redmond" });

     $("#Casier_12").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Plastique_12").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Bouteille_12").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Plastique_15").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Casier_15").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Bouteille_15").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Casier_24").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Plastique_24").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    $("#Bouteille_24").jqxInput({ height: 25, width: 75, theme: "ui-redmond" });
    
     $("#Quantite_Casier_Liquide").val("");    
     $("#Quantite_Bouteille_Liquide").val("");
     $("#Quantite_Casier_Emballage").val("");
     $("#Quantite_Plastique_Emballage").val("");
     $("#Quantite_Bouteille_Emballage").val("");

     $("#Quantite_Casier_Emballage_Retour").val("");
     $("#Quantite_Plastique_Emballage_Retour").val("");
     $("#Quantite_Bouteille_Emballage_Retour").val("");
     
     $('#Quantite_Casier_Liquide').on('keyup', function (event) {
         $("#Quantite_Casier_Emballage").val($('#Quantite_Casier_Liquide').val())
     });
    
     $('#Quantite_Bouteille_Liquide').on('keyup', function (event) {
         $("#Quantite_Bouteille_Emballage").val($('#Quantite_Bouteille_Liquide').val())
     });

     $("#Tout_Retourner").click(function () {
        if ($(this).is(':checked')) {
            $("#loaderSpace,#loader").show();
            $.ajax({
                url: '/Commande/LoadEmballage/', // le nom du fichier indiqué dans le formulaire
                type: 'GET', // la méthode indiquée dans le formulaire (get ou post)
                dataType: 'json'
            })
            .success(function (response) {
                $("#Casier_12").val(response[0]);
                $("#Plastique_12").val(response[1]);
                $("#Bouteille_12").val(response[2]);
                $("#Casier_15").val(response[3]);
                $("#Plastique_15").val(response[4]);
                $("#Bouteille_15").val(response[5]);
                $("#Casier_24").val(response[6]);
                $("#Plastique_24").val(response[7]);
                $("#Bouteille_24").val(response[8]);
                $("#Tout_Retourner").attr("checked", false);
                $("#loaderSpace,#loader").hide();
            })
            .error(function () {
                alert('echeck');
                $("#loaderSpace,#loader").hide();
            });
        } else {

        }
     });

    $(".action").off('click');
    $(".action").on('click', function () {
        $("#loaderSpace,#loader").show();
        var identifiantm = $(this).attr('id') + "Url";
        var urlm = $("#" + identifiantm).attr("value");

        var selectedRowsm = $("#gradesm").jqxGrid('getselectedrowindexes');
        var selectedRowsmemballage = $("#gradesmemballage").jqxGrid('getselectedrowindexes');
        if (identifiantm === 'supprimerUrl') {
            var tabm = '';
            $.each(selectedRowsm, function (index, row) {

                var lignem = $("#gradesm").jqxGrid('getrowdata', row);

                if (tabm == '')
                    tabm = lignem.id;
                else
                    tabm = tabm + ';' + lignem.id;
            });

            if (tabm === '') {
                $("#loaderSpace,#loader").hide();
                return false;
            }
            else
                urlm = urlm + tabm;
        }
        else if (identifiantm === 'supprimer_emballageUrl') {
            var tabm = '';
            $.each(selectedRowsmemballage, function (index, row) {

                var lignem = $("#gradesmemballage").jqxGrid('getrowdata', row);

                if (tabm == '')
                    tabm = lignem.id;
                else
                    tabm = tabm + ';' + lignem.id;
            });

            if (tabm === '') {
                $("#loaderSpace,#loader").hide();
                return false;
            }
            else
                urlm = urlm + tabm;
        }

        $.ajax({
            url: urlm,
            type: 'POST', // la méthode indiquée dans le formulaire (get ou post)
            data: $('form').serialize(), // je sérialise les données (voir plus loin), ici les $_POST             
            dataType: 'json',
            success: function (html) {
                $(".toast-item").remove();
                if (html.length == 5) {//c'est ok
                    if ((identifiantm === 'validerUrl') || (identifiantm === 'annulerUrl')) { // si on validait ou on annulait la commande                        
                        $('#formulaire').jqxWindow("destroy");
                        $("#grades").jqxGrid('updatebounddata', 'cells');
                        $("#grades").jqxGrid('clearselection');
                    }
                    else if ((identifiantm === 'materielUrl') || (identifiantm === 'supprimerUrl')) { // si  on ajoute ou on supprime les produit alors on recupere le montant de la facture ki est retourné dans le seconde element du tableau de retour                                             
                        $("#Montant").html(html[1].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
                        $("#Montant_Emballage_1").html(html[2].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));                     
                        $("#Retour_Emballage").html(html[3].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
                        $("#Quantite_Casier_Liquide").val("");
                        $("#Quantite_Bouteille_Liquide").val("");
                        $("#Quantite_Casier_Emballage").val("");
                        $("#Quantite_Plastique_Emballage").val("");
                        $("#Quantite_Bouteille_Emballage").val("");
                        $("#gradesm").jqxGrid('updatebounddata', 'cells');
                        $("#gradesm").jqxGrid('clearselection');
                    }
                    else if ((identifiantm === 'materiel_emballageUrl') || (identifiantm === 'supprimer_emballageUrl')) {
                        

                        $("#Montant").html(html[1].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
                        $("#Montant_Emballage").html(html[2].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
                        
                        $("#Retour_Emballage").html(html[3].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
                        $("#gradesmemballage").jqxGrid('updatebounddata', 'cells');
                        $("#gradesmemballage").jqxGrid('clearselection');
                    }
                    $('body').append(html[0]);
                }
                else {
                    $('body').append(html[0]);//affichage du message de retour renvoyé
                }
                $("#loaderSpace,#loader").hide();
            },
            error: function (jqXHR, exception) {
                $("#loaderSpace,#loader").hide();
                if (jqXHR.status === 0) {
                    alert('Not connect.\n Verify Network.');
                } else if (jqXHR.status == 404) {
                    alert('Requested page not found. [404]');
                } else if (jqXHR.status == 500) {
                    alert('Internal Server Error [500].');
                } else if (exception === 'parsererror') {
                    alert('Requested JSON parse failed.');
                } else if (exception === 'timeout') {
                    alert('Time out error.');
                } else if (exception === 'abort') {
                    alert('Ajax request aborted.');
                } else {
                    alert('Uncaught Error.\n' + jqXHR.responseText);
                }
            }
        });
        return false;
    });

    var columnsDatam = [{
        text: '', filterable: false, menu: false, sortable: false,
        datafield: 'available', columntype: 'checkbox',
        renderer: function () {
            return '<div style=" margin-top: 5px;"></div>';
        },
        rendered: function (elementm) {
            $(elementm).jqxCheckBox({ theme: "ui-redmond", width: 16, height: 16, animationShowDelay: 0, animationHideDelay: 0 });
            columnCheckBoxm = $(elementm);
            $(elementm).on('change', function (event) {
                var checkedm = event.args.checked;
                var pageinfom = $("#gradesm").jqxGrid('getpaginginformation');
                var pagenumm = pageinfom.pagenum;
                var pagesizem = pageinfom.pagesize;
                if (checkedm == null || updatingCheckStatem) return;
                $("#gradesm").jqxGrid('beginupdate');
                if (checkedm) {
                    $("#gradesm").jqxGrid('selectallrows');
                    $("#gradesm").jqxGrid('selectallrows', event.args.rowindex);
                }
                else if (checkedm == false) {
                    $("#gradesm").jqxGrid('clearselection');
                }
                var startrowm = pagenumm * pagesizem;
                for (var i = startrowm; i < startrowm + pagesizem; i++) {
                    var boundindex = $("#gradesm").jqxGrid('getrowboundindex', i);
                    $("#gradesm").jqxGrid('setcellvalue', boundindex, 'available', event.args.checked);
                }
                $("#gradesm").jqxGrid('endupdate');
            });
            return true;
        }
    },
    { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
    { text: 'Produit', editable: false, filtertype: 'textbox', datafield: 'Produit', width: '41%' },
    { text: 'Quantité', editable: false, filtertype: 'textbox', datafield: 'Quantite', cellsformat: 'd', width: '19%' },
    { text: 'Prix Unitaire', editable: false, filtertype: 'textbox', datafield: 'Prix_Liquide', cellsformat: 'd', width: '19%' },

    ];

    //grid
    var sourcem =
    {
        datatype: "json",
        url: '/Commande/ajaxLiquide',
        datafields: [
                    { name: 'id', type: 'string' },
                    { name: 'Produit', type: 'string' },
                    { name: 'Quantite_Casier_Liquide', type: 'number' },
                    { name: 'Quantite_Bouteille_Liquide', type: 'number' },
                    { name: 'Quantite_Casier_Emballage', type: 'number' },
                    { name: 'Quantite_Plastique_Emballage', type: 'number' },
                    { name: 'Quantite_Bouteille_Emballage', type: 'number' },
                    { name: 'PU_Achat', type: 'number' },
                    { name: 'Montant_Liquide', type: 'number' },
                    { name: 'Montant_Emballage', type: 'number' },
                    { name: 'Total', type: 'number' },
        ],
        cache: false,
        updaterow: function (rowid, rowdata, commit) {
            commit(true);
        },
        deleterow: function (rowid, commit) {
            commit(true);
        }
    };
    var columnCheckBoxm = null;
    var updatingCheckStatem = false;
    var dataadapterm = new $.jqx.dataAdapter(sourcem, {
        loadError: function (xhr, status, error) {
            alert(error);
        }
    });

    // initialize grades
    $("#gradesm").jqxGrid(
    {
        columnsresize: true,
        editable: true,
        width: '98%',
        source: dataadapterm,
        selectionmode: 'checkbox',
        sortable: false,
        pageable: false,
        autoheight: true,
        showfilterrow: false,
        filterable: false,
        theme: "ui-redmond",
        localization: getLocalization(),
        
        columns: [
            { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
            { text: 'Produit', align: 'center',editable: false, filtertype: 'textbox', datafield: 'Produit', width: '20.7%' },
            { text: 'Casier', columngroup: 'Liquide', align: 'center', editable: true, filtertype: 'textbox',cellsalign: 'right', datafield: 'Quantite_Casier_Liquide', cellsformat: 'd', width: '8%' },
            { text: 'Bouteille', columngroup: 'Liquide', align: 'center', editable: true, filtertype: 'textbox',cellsalign: 'right', datafield: 'Quantite_Bouteille_Liquide', cellsformat: 'd', width: '8%' },
            { text: 'PU', columngroup: 'Liquide', align: 'center', editable: false, filtertype: 'textbox', cellsalign: 'right', datafield: 'PU_Achat', cellsformat: 'd', width: '8%' },
            { text: 'Casier', columngroup: 'Emballage', align: 'center', editable: true, filtertype: 'textbox',cellsalign: 'right', datafield: 'Quantite_Casier_Emballage', cellsformat: 'd', width: '8%' },
            { text: 'Plastique', columngroup: 'Emballage', align: 'center', editable: true, filtertype: 'textbox',cellsalign: 'right', datafield: 'Quantite_Plastique_Emballage', cellsformat: 'd', width: '8%' },
            { text: 'Bouteille', columngroup: 'Emballage', align: 'center', editable: true, filtertype: 'textbox',cellsalign: 'right', datafield: 'Quantite_Bouteille_Emballage', cellsformat: 'd', width: '8%' },
            { text: 'Liquide',columngroup: 'Montant', editable: false, align: 'center', filtertype: 'textbox',cellsalign: 'right', datafield: 'Montant_Liquide', cellsformat: 'd', width: '8%' },
            { text: 'Emballage', columngroup: 'Montant', editable: false, align: 'center', filtertype: 'textbox',cellsalign: 'right', datafield: 'Montant_Emballage', cellsformat: 'd', width: '8%' },
            { text: 'TOTAL', editable: false, align: 'center', filtertype: 'textbox',cellsalign: 'right', datafield: 'Total', cellsformat: 'd', width: '12.7%' },
        ],
        columngroups: [
                    { text: 'Liquide', align: 'center', name: 'Liquide' },
					{ text: 'Emballage', align: 'center', name: 'Emballage' },
					{ text: 'Montant', align: 'center', name: 'Montant' },
        ]
    });

    $("#gradesm").on('bindingcomplete', function (event) {
        $('#gradesm').jqxGrid({ pagesizeoptions: ['10', '20', '50'] });
        $('#gradesm').jqxGrid('pagesize', 10);
    });

    // select or unselect rows when a checkbox is checked or unchecked. 
    $("#gradesm").on('cellvaluechanged', function (event) {
        if (event.args.value) {
            $("#gradesm").jqxGrid('selectrow', event.args.rowindex);
        }
        else {
            $("#gradesm").jqxGrid('unselectrow', event.args.rowindex);
        }
        // update the state of the column's checkbox. When all checkboxes on the displayed page are checked, we need to check column's checkbox. We uncheck it,
        // when there are no checked checkboxes on the page and set it to intederminate state when there is at least one checkbox checked on the page.  
        if (columnCheckBoxm) {
            var datainfom = $("#gradesm").jqxGrid('getdatainformation');
            var pagesizem = datainfom.paginginformation.pagesize;
            var pagenumm = datainfom.paginginformation.pagenum;
            var selectedRowsm = $("#gradesm").jqxGrid('getselectedrowindexes');
            var statem = false;
            var countm = 0;
            $.each(selectedRowsm, function () {
                if (pagenumm * pagesizem <= this && this < pagenumm * pagesizem + pagesizem) {
                    countm++;
                }
            });

            if (countm != 0) statem = null;
            if (countm == pagesizem) statem = true;
            if (countm == 0) statem = false;

            updatingCheckStatem = true;
            $(columnCheckBoxm).jqxCheckBox({ checked: statem });

            updatingCheckStatem = false;
        }
    });


    $("#C_ID_Type_Produit").on('select', function (event) {
        if (event.args) {
            var args = event.args;
            var index = args.item.index;
            $("#ID_Type_Produit").val(args.item.value);
            charger_Emballage();
        }
    });
    charger_Emballage = function () {
        $("#loaderSpace,#loader").show();
        $.ajax({
            url: '/Commande/GetEmballageByFournisseur/' + $("#ID_Type_Produit").val(), // le nom du fichier indiqué dans le formulaire
            type: 'POST', // la méthode indiquée dans le formulaire (get ou post)
            dataType: 'json'
        })
        .success(function (response) {
            $('#ID_Emballage option').remove();
            $.each(response, function (index, val) {
                var optionTag = $('<option></option>');
                $(optionTag).val(val.Value).text(val.Text);
                $('#ID_Emballage').append(optionTag);
            });
            $("#C_ID_Emballage").jqxDropDownList({ theme: "ui-redmond", width: '280' });
            $("#C_ID_Emballage").jqxDropDownList('loadFromSelect', 'ID_Emballage');
            $("#C_ID_Emballage").jqxDropDownList('selectedIndex', '0');
            $("#loaderSpace,#loader").hide();
        })
        .error(function () {
            alert('echeck');
            $("#loaderSpace,#loader").hide();
        });
    };


    /////////////////////////////////////////////
    var columnsDatamemballage = [{
        text: '', filterable: false, menu: false, sortable: false,
        datafield: 'available', columntype: 'checkbox',
        renderer: function () {
            return '<div style=" margin-top: 5px;"></div>';
        },
        rendered: function (elementm) {
            $(elementm).jqxCheckBox({ theme: "ui-redmond", width: 16, height: 16, animationShowDelay: 0, animationHideDelay: 0 });
            columnCheckBoxmemballage = $(elementm);
            $(elementm).on('change', function (event) {
                var checkedm = event.args.checked;
                var pageinfom = $("#gradesmemballage").jqxGrid('getpaginginformation');
                var pagenumm = pageinfom.pagenum;
                var pagesizem = pageinfom.pagesize;
                if (checkedm == null || updatingCheckStatememballage) return;
                $("#gradesmemballage").jqxGrid('beginupdate');
                if (checkedm) {
                    $("#gradesmemballage").jqxGrid('selectallrows');
                    $("#gradesmemballage").jqxGrid('selectallrows', event.args.rowindex);
                }
                else if (checkedm == false) {
                    $("#gradesmemballage").jqxGrid('clearselection');
                }
                var startrowm = pagenumm * pagesizem;
                for (var i = startrowm; i < startrowm + pagesizem; i++) {
                    var boundindex = $("#gradesmemballage").jqxGrid('getrowboundindex', i);
                    $("#gradesmemballage").jqxGrid('setcellvalue', boundindex, 'available', event.args.checked);
                }
                $("#gradesmemballage").jqxGrid('endupdate');
            });
            return true;
        }
    },
    { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
    { text: 'Produit', editable: false, filtertype: 'textbox', datafield: 'Produit', width: '41%' },
    { text: 'Quantité', editable: false, filtertype: 'textbox', datafield: 'Quantite', cellsformat: 'd', width: '19%' },
    { text: 'Prix Unitaire', editable: false, filtertype: 'textbox', datafield: 'Prix_Liquide', cellsformat: 'd', width: '19%' },

    ];
    var sourcememballage =
   {
       datatype: "json",
       url: '/Commande/ajaxEmballage',
       datafields: [
                   { name: 'id', type: 'string' },
                   { name: 'Emballage', type: 'string' },
                   { name: 'Quantite_Casier', type: 'number' },
                   { name: 'Quantite_Plastique', type: 'number' },
                   { name: 'Quantite_Bouteille', type: 'number' },
                   { name: 'Montant', type: 'number' },
       ],
       cache: false,
       updaterow: function (rowid, rowdata, commit) {
           commit(true);
       },
       deleterow: function (rowid, commit) {
           commit(true);
       }
   };
    var columnCheckBoxmemballage = null;
    var updatingCheckStatememballage = false;
    var dataadaptermemballage = new $.jqx.dataAdapter(sourcememballage, {
        loadError: function (xhr, status, error) {
            alert(error);
        }
    });
    $("#gradesmemballage").jqxGrid(
    {
        columnsresize: true,
        editable: true,
        width: '98%',
        source: dataadaptermemballage,
        selectionmode: 'checkbox',
        sortable: false,
        pageable: false,
        autoheight: true,
        showfilterrow: false,
        filterable: false,
        theme: "ui-redmond",
        localization: getLocalization(),
        columns: [
            { text: 'id', editable: false, filtertype: 'textbox', datafield: 'id', hidden: true },
            { text: 'Emballage', editable: false, filtertype: 'textbox', datafield: 'Emballage', width: '29.1%' },
            { text: 'Casier', editable: false, filtertype: 'textbox', datafield: 'Quantite_Casier', cellsformat: 'd', width: '17.3%' },
            { text: 'Plastique', editable: false, filtertype: 'textbox', datafield: 'Quantite_Plastique', cellsformat: 'd', width: '15%' },
            { text: 'Bouteille', editable: false, filtertype: 'textbox', datafield: 'Quantite_Bouteille', cellsformat: 'd', width: '15%' },
            { text: 'Montant', editable: false, filtertype: 'textbox', datafield: 'Montant', cellsformat: 'd', width: '21%' },
        ]
    });

    $("#gradesmemballage").on('bindingcomplete', function (event) {
        $('#gradesmemballage').jqxGrid({ pagesizeoptions: ['10', '20', '50'] });
        $('#gradesmemballage').jqxGrid('pagesize', 10);
    });

     $("#gradesm").on('cellendedit', function (event) {
        if (args.datafield == "Quantite_Casier_Liquide") {                      
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 1, args.value);
            }
            
        } else if (args.datafield == "Quantite_Bouteille_Liquide") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 2, args.value);
            }

        } else if (args.datafield == "Quantite_Casier_Emballage") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 3, args.value);
            }

        } else if (args.datafield == "Quantite_Plastique_Emballage") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 4, args.value);
            }

        } else if (args.datafield == "Quantite_Bouteille_Emballage") {
            if (!IsNumber_OUF(args.value) || parseInt(args.value) < 0) {
                $('#messages').jqxWindow('setContent', 'Cette valeur doit être un nombre positif');
                $('#messages').jqxWindow({ width: "auto" });
                $('#messages').jqxWindow({ height: "auto" });
                $('#messages').jqxWindow("open");
                return false;
            }
            else {
                var row = args.rowindex;
                var data = $('#gradesm').jqxGrid('getrowdata', row);
                Edit_Grille(data.id, 5, args.value);
            }

        } 
    });
    Edit_Grille = function (id,key, value) {
        $("#loaderSpace,#loader").show();

        $.ajax({
            url: '/Commande/Edit_Grille/?id=' + id + '&key=' + key + '&value=' + value, // le nom du fichier indiqué dans le formulaire
            type: 'GET', // la méthode indiquée dans le formulaire (get ou post)
            dataType: 'json'
        })
      .success(function (response) {
         
          $("#Montant").html(response[1].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
          $("#Montant_Emballage_1").html(response[2].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
                      
          $("#Retour_Emballage").html(response[3].toString().replace(/(\d)(?=(?:\d{3})+(?:$))/g, '$1 '));
          $("#gradesm").jqxGrid('updatebounddata', 'cells');
          $("#gradesm").jqxGrid('clearselection');
          $("body").append(response);
          $("#loaderSpace,#loader").hide();
      })
      .error(function () {
          alert('echeck');
          $("#loaderSpace,#loader").hide();
      });
    }


    // select or unselect rows when a checkbox is checked or unchecked. 
    $("#gradesmemballage").on('cellvaluechanged', function (event) {
        if (event.args.value) {
            $("#gradesmemballage").jqxGrid('selectrow', event.args.rowindex);
        }
        else {
            $("#gradesmemballage").jqxGrid('unselectrow', event.args.rowindex);
        }
        // update the state of the column's checkbox. When all checkboxes on the displayed page are checked, we need to check column's checkbox. We uncheck it,
        // when there are no checked checkboxes on the page and set it to intederminate state when there is at least one checkbox checked on the page.  
        if (columnCheckBoxmemballage) {
            var datainfom = $("#gradesmemballage").jqxGrid('getdatainformation');
            var pagesizem = datainfom.paginginformation.pagesize;
            var pagenumm = datainfom.paginginformation.pagenum;
            var selectedRowsm = $("#gradesmemballage").jqxGrid('getselectedrowindexes');
            var statem = false;
            var countm = 0;
            $.each(selectedRowsm, function () {
                if (pagenumm * pagesizem <= this && this < pagenumm * pagesizem + pagesizem) {
                    countm++;
                }
            });

            if (countm != 0) statem = null;
            if (countm == pagesizem) statem = true;
            if (countm == 0) statem = false;

            updatingCheckStatememballage = true;
            $(columnCheckBoxmemballage).jqxCheckBox({ checked: statem });

            updatingCheckStatememballage = false;
        }
    });

    
    /////////////////////////////////////////////
</script>
<style >
    .section {
        padding:3px;
    }
    #gradesm, #gradesmemballage {
        margin: 8px;
    }
     #Quantite_Liquide
    {
        visibility:hidden;
        display:none;
    }
    

     th{
        background: none repeat scroll 0 0 #FFF;
        border-color: #999999;
        color: #000000;
        font-family: Lucida Grande,Lucida Sans,Arial,sans-serif;
        font-size: 13px;
        text-align: center;
        font-weight: bold;
        height: auto;
        outline: medium none;
        overflow: hidden;
        padding: 5px;
        white-space: nowrap;
        line-height: 1.231;
        -moz-user-select: none;
        font-style: normal;
        cursor: default;
        direction: ltr;
    }

    table.td {
        background: url("images/redmond/ui-bg_inset-hard_100_fcfdfd_1x100.png") repeat-x scroll 50% bottom #FCFDFD;
        border-color: #999999;
        color: #222222;
        font-family: Lucida Grande,Lucida Sans,Arial,sans-serif;
        font-size: 13px;
        line-height: 20px;
        vertical-align: top;
        padding: 5px;
    }

    table.encadrer, tr.encadrer, td.encadrer, th {
        border: thin solid #7c7777;
    }
    #Montant_Liquide, #Montant_Emballage, #Montant_Emballage_Retour {
         visibility:hidden;
        display:none;
    }
    
</style>